      subroutine inbreed(n,pedig,aveinb,round)
c Having PEDIGrees of N animals, their Birthdates, calculate
c inbreeding coefficients. Statistics are printed only during the first round
c The algorithm is to extract a pedigree for every animal and calculate
c the inbreeding using the tabular method. Unknown parents
c have inbreeding coefficients corresponding to animals with pedigree
c information and born in same years, as in a paper by Paul VanRaden@1992,
c to be published in JDS.
c
c Pedig has 4 fields: sire_id    dam_id    year_of_bith    inbreeding
c
      integer n,pedig(4,n),i,ia,j,k,l1,l2,fammax,round,msglev/0/
      parameter (fammax=300)
      integer family(4,fammax),l2n,l2max
      real aveinb(100),inb(fammax),l2ave
c
      l2n=0
      l2ave=0
      l2max=0
c iterate to compute inbreeding information for animals with unknown parents
       call tabular(family,0,4,aveinb,100,inb)

c       not_processed code = -1
       do i=1,n
         pedig(4,i)=-1
       enddo
       do i=1,n
c          skip animals already processed
         if (pedig(4,i).lt.0) then
c             extract pedigree of animal i to family
             l1=1
             l2=1
             family(1,1)=pedig(1,i)
             family(2,1)=pedig(2,i)
             family(3,1)=i
             family(4,1)=pedig(3,i)

c              temporarily tag; lock relationship to avoid looping
             pedig(4,i)=-2
c              build relationships recursively
             do while (l1.le.l2)
               do k=1,2
                  if (family(k,l1).ne.0) then
                      ia=family(k,l1)
                      if (pedig(4,ia).ne.-2) then
                          l2=l2+1
                          if (l2.gt.fammax) then
                              print*,'increase femmax in HAINB'
                              stop
                           endif
                          family(1,l2)=pedig(1,ia)
                          family(2,l2)=pedig(2,ia)
                          family(3,l2)=ia
                          family(4,l2)=pedig(3,ia)
                          pedig(4,ia)=-2
                      endif
                  endif
                enddo
                l1=l1+1
             enddo
             l2ave=l2ave+l2
             l2n=l2n+1
             l2max=max(l2,l2max)
             if (msglev.ge.2) call printmat('extract',family,4,l2,1)
c
c             sort by birth year
             call sortqms(family,l2,4,l2,4,4,1)
             if (msglev.ge.3) call printmat('sort',family,4,l2,1)

c             renumber first 2 fields
             call rentab(family,4,l2)
             if (msglev.ge.3) call printmat('renumb',family,4,l2,1)

c             assign (year_of_birth  - 100) to unknown parents
             do j=1,l2
                do k=1,2
                  if (family(k,j).eq.0) then
                      family(k,j)=family(4,j)-100
                  endif
                enddo
             enddo

c             call tabular method
             call tabular(family,l2,4,aveinb,0,inb)
             if (msglev.ge.3) print*,'inb=',(inb(j),j=1,l2)

c              save inbreeding coefficients
             do j=1,l2
                pedig(4,family(3,j))=inb(j)*1000
             enddo
         endif
        enddo
      if (round.eq.1) print 10,l2n,l2max,l2ave/l2n
10    format('   processed ',i6,' families of size max, ave:',i4,f7.1)
      end
