c last updated 02/14/96

      logical function extrap_r(n,var,round,conv,r)
c extrapolates var so that r=1 for all random effects
      integer n, round,last/0/,maxseq,round_off,i
      parameter(maxseq=1500)
      real var(n),r(n),convhist(maxseq),rhist(10,maxseq)
      real*8 conv
      logical converged,r1
      save rhist,convhist
c
      extrap_r=.false.
      round_off=round-last
      if (round_off.gt.maxseq) stop
      convhist(round_off)=conv
      do i=1,n
         rhist(i,round_off)=r(i)
      enddo

      if (converged(round_off,n,rhist)) then
          if (r1(r,var,n)) then
              extrap_r=.true.
c-------------adjust solutions based on last A and b, and
c-------------compute sensitivity of var on r
              call finetune(r,var,n)
            else
             call update(r,var,n)
             last=round
          endif
      endif
      end

      subroutine finetune(r,var,n)
c During the last round adjust variance to account for r <>1 and
c prints sensitivity of var to r. 
c
      real r(10),var(10),v(10),v1(10),v2(10),sum/1./
      real*8 a(10,10)
      integer n,n1/0/,p(10),i,j
      logical first
      common /rex/first,a
c
      do i=1,n
         if (var(i).ne.0) then
            n1=n1+1
            p(n1)=i
         endif
      enddo
c
      if (first) then
      do i=1,n1
         v(i)=abs(var(p(i)))
         sum=sum+1/v(i)
      enddo

       print'(''effect   R    variance ratio   relative variance [%]'')'
        do i=1,n1
           print '(i6,f10.5,f12.3,f20.2,5x,f6.2,''-'',f6.2)',
     +                   p(i),r(p(i)),v(i),100/sum/v(i)
        enddo
        print '(a8,17x,f23.2/)','residual',100/sum
        return
      endif
c
      print*,'before adjustment', (var(p(i)),i=1,n1)
c  var = var + A(1-r)
      do i=1,n1
         v(i)=abs(var(p(i)))
         do j=1,n1
            v(i)=v(i)+a(i,j)*(1-r(p(j)))
         enddo
         if (v(i).ne.0) sum=sum+1/v(i)
         var(p(i))=sign(v(i),var(p(i)))
      enddo

      print*,'after adjustment: var', (var(p(i)),i=1,n1)
      print*

c v1= var + A(1.0001-r)
c v1= var + A(.9999-r)
      do i=1,n1
         v1(i)=v(i)
         v2(i)=v(i)
         do j=1,n1
            v1(i)=v1(i)+a(i,j)*(.0002)
            v2(i)=v2(i)+a(i,j)*(-.0002)
         enddo
      enddo

      print 10
10    format('effect   R    variance ratio*  relative variance [%]',
     +     '   range(r=.9998-1.0002)')
      do i=1,n1
           print '(i6,f10.5,f12.3,f20.2,6x,f6.2,''-'',f5.2)',
     +                   p(i),r(p(i)),v(i),100/sum/v(i),
     +                   100/sum/v1(i),100/sum/v2(i)
      enddo
      print '(a8,17x,f23.2)','residual',100/sum
      print*,'   *variance ratios have been adjusted to r=1'
      end

      logical function r1(x,var,n)
c true if all x#0 are close to 1 within eps
      integer i
      real x(n),var(n),eps/.0002/
c
          r1=.true.
          do i=1,n
             if (var(i).ne.0) then
                if (abs(x(i)-1.0) .gt. eps) r1=.false.
             endif
          enddo
          if (r1)  print'(/'' Convergence!''/)'          
      end


      function converged(n,m,x)
c finds if values in rhist() converge within a minimum, i.e., 3 consecutive
c changes are smaller than eps
      logical converged
      integer m,n,i,j,k
      real x(10,n),y(10),eps/1e-6/,eps1
c
      if (n.lt.5) then
         converged=.false.
        else
         converged=.true.
         eps1=eps
         do i=n-2,n
             do j=1,m
               if (x(j,i).ne.0 .and. abs(x(j,i)-x(j,i-1)).gt.eps1) then
                  eps1=abs(x(j,i)-x(j,i-1))
                  if (eps1.gt.1) then
                     print*,i,j,x(j,i),x(j,i-1), abs(x(j,i)-x(j,i-1))
                  endif
                  converged=.false.
               endif
             enddo
         enddo
      endif

c print r and max difference
      k=0
      do i=1,10
         if (x(i,n).ne.0) then
            k=k+1
            y(k)=x(i,n)
         endif
      enddo
      print 10,eps1,(y(i),i=1,k)
10    format(' max diff = ',e10.2,'  r=',10f9.6)
      end

      subroutine update(r,var,n)
c updates variance ratios given Rs and histories; delta is a part of the variance; in terms
c of residual variance, that is used to generate approximate partial derivatives.
      integer n,step/0/,index(10),nv/0/,i,i1,j
      real r(n),var(n),sol(10),change,delta/.005/
      real*8 oldvar(10,10),oldr(10,10)
      logical first/.true./,good_fit
      save step,first,index,oldvar,oldr
c
c first time count and index random effects
      if (first) then
         first=.false.
         do i=1,n
            if (var(i).ne.0) then
               nv=nv+1
               index(nv)=i
            endif
         enddo
      endif
c
      step=step+1
      do i=1,nv
         i1=index(i)
         oldvar(i,step)=abs(var(i1))
         oldr(i,step)=r(i1)
      enddo
      print 10,(oldr(i,step),i=1,nv)
      write(*,11)(oldvar(i,step),i=1,nv)
10    format(' iteration converged to r=',8f9.5)
11    format('+  at variance ratios=',8f8.2)

c      print'(''step,var,r'',i2,20f6.3)',step,(var(i),i=1,n),(r(i),i=1,n)
c      print'(''oldvar'',20f6.3)',((oldvar(i,j),j=1,step),i=1,nv)
c      print'(''oldr'',20f6.3)',((oldr(i,j),j=1,step),i=1,nv)

c extrapolate if nv+1 samples known
      if (step.le.nv) then
c---------create as many samples as there are variance components
          change=min(.5,1./(1/abs(var(index(step)))/delta+1))
          print*,'ch',change,1./(1/abs(var(index(step)))/delta+1)
          if (r(index(step)).gt.1) then
            var(index(step))=var(index(step))*(1-change)
            else
             var(index(step))=var(index(step))*(1+change)
          endif
        else
c---------extrapolate
         call rextrap(nv,sol,oldvar,oldr,good_fit)
         print*,' Extrapolation!'
         do i=1,nv
            i1=index(i)
            var(i1)=sign(sol(i),var(i1))
         enddo

         if (good_fit) then
c-----------old points good; just remove the oldest point
            do i=1,nv
               do j=1,nv
                 oldvar(j,i)=oldvar(j,i+1)
                 oldr(j,i)=oldr(j,i+1)
               enddo
            enddo
            step=nv
          else
c-----------old points far away; start from scratch
            step=0
         endif
       endif
      print'(''new variance ratios='',8f8.2)',(var(i),i=1,n)
      end


      subroutine rextrap(n,x1,oldvar,oldr,good_fit)
c find new point based on old points using linear extrapolation;
      integer n,i,j,k
      real x1(10),z
      real*8 oldvar(10,10),oldr(10,10),a(10,10),x(10,10),y(10,10),
     +       maxchange/.7/,max_good_fit/.1/
      logical good_fit,first
      common /rex/first,a
      data first/.true./
c
      first=.false.
      do i=1,n
        do j=1,n
           y(i,j)=oldr(i,j+1)-oldr(i,j)
           x(i,j)=oldvar(i,j+1)-oldvar(i,j)
        enddo
      enddo
     
      call printmat(oldvar,n+1,10,'(10g15.7)','Matrix oldvar')
      call printmat(oldr,n+1,10,'(10g15.7)','Matrix oldr') 
      call printmat(x,n,10,'(10g15.7)','Matrix x')
      call printmat(y,n,10,'(10g15.7)','Matrix y')         
c
c a=y*inv(x)
      call invert(n,x,10)
c      print'(''inv x'',20f6.3)',((x(i,j),i=1,n),j=1,n)
      do i=1,n
        do j=1,n
           a(i,j)=0
           do k=1,n
              a(i,j)=a(i,j)+y(i,k)*x(k,j)
           enddo
        enddo
      enddo

c      print'(''a'',20f6.3)',((a(i,j),i=1,n),j=1,n)
       call printmat(a,n,10,'(10g15.7)','Matrix A')
c
c [ old formula  b=y(n)-a*x(n])
c
c x1 = x(n) + inv(a)(1-y(n)) 
      do i=1,n
         a(i,i)=a(i,i)
      enddo
      call invert(n,a,10)
      do i=1,n
         x1(i)=oldvar(i,n+1)
         do j=1,n
            x1(i)=x1(i)+a(i,j)*(1-oldr(j,n+1))
         enddo
      enddo
      call printmat(a,n,10,'(10g15.7)','Matrix inv(A)')
      print*,'x1',(x1(i),i=1,n)  

c restrict change to maxchange
      diff=0
      do i=1,n
         z=abs((x1(i)-oldvar(i,n+1))/oldvar(i,n+1))
         diff=max(diff,z)
      enddo
      print*,'diff=', diff

      if (diff.lt.max_good_fit) then
          good_fit=.true.
        else
          good_fit=.false.
      endif

      if (diff.gt.maxchange) then
        diff=maxchange/diff
        print*,'corrected diff=',diff
        do i=1,n
          x1(i)=oldvar(i,n+1)+diff*(x1(i)-oldvar(i,n+1))
         enddo
         print*,'corrected x1',(x1(i),i=1,n)
      endif

c
c  .2 < x1 < 10000 & max change is maxchange
      do i=1,n
         if (x1(i).gt.10000) x1(i)=10000
         if (x1(i) .lt. .2) x1(i)=.2
c         diff =x1(i)/oldvar(i,n+1)
c         if (diff.gt.maxchange) then
c                x1(i)=(maxchange+rndsmp(.1))*oldvar(i,n+1)
c             elseif (diff .lt. 1./maxchange) then
c                x1(i)=oldvar(i,n+1)*1./(maxchange+rndsmp(.1))
c         endif
      enddo

      end

      subroutine printmat(x,n,m,form,text)
c Print n rows and columns of matrix x(m,m) in format form, preceded
c by text.
      integer n,m,i,j
      character form*(*),text*(*)
      real*8 x(m,m)
      print*, ' ',text
      do i=1,n
         print form,(x(i,j),j=1,n)
      enddo
      end
