*  Copyright I. Misztal, University of Georgia (1/18/95-12/31/96 )
c***********************************************************************
      program rendom
c Computes files necessary to easily calculate inverse of dominance 
c relationship matrix
c It relies on files in JAA format
c***********************************************************************
 
c memory assigned to the largest variables in the program; in bytes
      integer relmax,dommax,relpasses
      parameter (relmax=80 000,dommax=200 000)
      integer rel(4,relmax),dom(8,dommax),i,j,k,l,m,n,an,
     +        nrellast,nreclast,nposlast,nanimpos,x(50),
     +        ndomrec/0/,nrel/0/,nrec/0/,nunk/0/,ndom/0/,ndomold,
     +        maxanim/0/,holes/0/,unk(2)/2*0/,nelim/0/,nelim1/0/,
     +        msglev/0/,unkstat(relmax),npresent,nabsent
      character*20 namepar,namerel,namerec,a,buf*80,xc(50)*10,
     +             id(relmax)*10
      logical new

      print*,'RENDOMN 12/31/96'
c read JAA parameter file 
      print*,'Jaa parameter file?'
      read '(a)',namepar
      print*,'max recursions?'
      read*,relpasses

      call jaadecode
     +    (namepar,namerel,namerec,nrellast,nreclast,nposlast,nanimpos)
      open(10,file=namerel)
      open(11,file=namerec)
      open(12,file='domd'//namerel)
      open(15,file='dom'//namepar)
      open(16,file='d'//namerel)
      open(17,file='domrec'//namerec)
      open(18,file='domid'//namerel)

      call zero(relmax*4,rel)
      call zero(dommax*8,dom)

c read relationship file, with format as:
c animal, sire, dam, code of unknown parents, year of birth, alphanumeric id
      nrel=0
 
10    read(10,'(a)',end=20)buf
      call nums(buf,x,xc,50,m)
      if (m.lt.6) then
         print*,'Relationship file has fewer than 6 components:',m
         print*,a
         stop
      endif
      an=x(1)
      nrel=nrel+1
      if (an.gt.relmax) then
         print*,'increase relmax to at least: ',an
         stop
      endif
      rel(1,an)=x(2)
      rel(2,an)=x(3)
      rel(3,an)=x(5)
      unkstat(an)=-1
      id(an)=xc(6)
      goto 10
20    print '('' read'',i8,'' pedigree records'')',nrel

      if (msglev.ge.2) call printtable('pedigree',rel,3,relmax)

c find code of the top animal and calculate the number of holes in the pedigree
      do i=1,relmax
         if (unkstat(i).ne.0) then
            maxanim=i
           else
            holes=holes+1
         endif
      enddo
      print*,'largest animal no is',maxanim,' and pedigree contained',
     +       holes-(relmax-maxanim),' holes'

c zero unknown parent groups assumed to be numbers > maxanim
      do i=1,relmax
         do j=1,2
            if (rel(j,i).gt.maxanim) then
               unk(j)=unk(j)+1
               rel(j,i)=0
            endif
         enddo
      enddo
      print*,'zeroed',unk,' groups for parent 1 and 2'

c load parents of animals with records
      nrec=0
      nunk=0

30    read(11,*,end=40)(x(i),i=1,nanimpos)
      an=x(nanimpos)
      nrec=nrec+1
      if (unkstat(an).eq.0) then
           print*,'no pedigree for animal ',an
        elseif( rel(1,an)*rel(2,an).eq.0) then
           if (unkstat(an).lt.0) then
               nunk=nunk+1
               unkstat(an)=nunk
           endif
        else
           call loadando(rel(1,an),dom,8,dommax,ndom,k,new)
           if (new) then 
              dom(7,k)=1
              dom(8,k)=ndom
           endif
      endif
      goto 30

40    ndomrec=ndom
      if (msglev.ge.2) then
         call printtable('pedigree after reading records',rel,3,relmax)
         call printtable('domin',dom,8,dommax)
      endif

c calculate inbreeding
      call inbr(rel,maxanim)


      print*,'Read ',nrec,' records'
      print*,'Created ',ndomrec,
     +       ' classes with known parents and ',nunk,' with unknown'

c Expand the dominance pedigrees in several iterations (up to relpasses)
      do i=1,relpasses
c------- load parents of parents 
         ndomold=ndom
         do j=1,dommax
            if (dom(7,j).eq.1) then
               dom(3,j)=rel(1,dom(1,j))
               dom(4,j)=rel(2,dom(1,j))
               dom(5,j)=rel(1,dom(2,j))
               dom(6,j)=rel(2,dom(2,j))
               dom(7,j)=2
            endif
         enddo
c--------expand
         do j=1,dommax
            if (dom(7,j).eq.2) then
               call expand(j,dom,dommax,ndom)
            endif
         enddo
         if (ndomold.eq.ndom) goto 50
         print*,'after pass',i, '; added',ndom-ndomold,' combinations'
         if (msglev.ge.3) call printtable('domin',dom,8,dommax)
      enddo
50    continue
      print '('' In total'',i8,'' combinations'')',ndom

c eliminate animals with a single presence dom(7,*) will contain a number of
c references+1 for animals without records and a high number with records
      do i=1,dommax
         if (dom(7,i).ne.0) then
            if (dom(8,i).ne.0) then
               dom(7,i)=100
              else
               dom(7,i)=1
            endif
         endif
      enddo
      do i=1,dommax
         if (dom(7,i).ne.0) then
            call tag(i,dom,dommax,ndom)
         endif
      enddo
      if (msglev.ge.3) call printtable('tags',dom,8,dommax)

c remove combinations with a tag of 2 and without grandparent information
      nelim=0
      do i=1,dommax
         if (dom(7,i).eq.1) then
              print*,'error 234'
            elseif (dom(7,i).eq.2) then
              if (dom(3,i)+dom(4,i)+dom(5,i)+dom(6,i).eq.0) then
                 dom(7,i)=0
                 dom(1,i)=-1
                 nelim=nelim+1
                else
                 nelim1=nelim1+1
              endif
        endif
      enddo
      print '('' eliminated'',i8,'' combinations; left '',i8)',
     +      nelim,ndom-nelim
      print '('' perhaps could eliminate'',i8,'' more'')',nelim1

c add consective numbers
c-----relationships with nonzero parents first
      npresent=0
      do j=1,dommax
         if (dom(7,j).ne.0 .and. 
     +        dom(3,j)+dom(4,j)+dom(5,j)+dom(6,j).ne.0) then
            npresent=npresent+1
            dom(8,j)=npresent
         endif
      enddo
c-----relationships with zero parents next
      nabsent=0
      do j=1,dommax
         if (dom(7,j).ne.0 .and.
     +        dom(3,j)+dom(4,j)+dom(5,j)+dom(6,j).eq.0) then
             nabsent=nabsent+1
             dom(8,j)=nabsent+npresent
         endif
      enddo

      print*,'created ',npresent,' dominance pedigrees'
      print*,nabsent,' classes have no parent classes'

      if (msglev.ge.2) call printtable('domin',dom,8,dommax)

c create the new additive relationship file, with 4th parameter replaced
c by 1,2/3,1/2, depending on # of unknown parents, multiplied by 1000/(1+F)
      call creatrel(nrel,maxanim,rel,id,10,16)

c create the dominance file
      call creat1dom(dom,8,dommax,12,18,id)

c create new observations' file with dominance and inbreeding
      rewind 11
      j=ndomrec
      k=0
      do i=1,nrec
        read(11,*)(x(l),l=1,nposlast)
        an=x(nanimpos)
        x(nposlast+1)=rel(4,an)
        if( unkstat(an).gt.0) then
           x(nposlast+2)=npresent+nabsent+unkstat(an)
        else
           call checkando(rel(1,an),dom,8,dommax,ndom,k)
           if (k.eq.0) then
              print*,'this should not happen:245'
              stop
           endif
           x(nposlast+2)=dom(8,k)
        endif
        call pack(buf,n,x,nposlast+2)
        write(17,'(a)')buf(1:n)
      enddo

c create a reworked jaa-style parameter file
      call createparfile
     +      (namepar,15,nrel,npresent,npresent+nabsent+nunk,nposlast)
      end

      subroutine expand(j,dom,dommax,ndom)
c creates new dominance combinations out of parent and grandparent subclasses;
      integer j,dommax,ndom,dom(8,dommax),comb(2,8),x(2),i,k,l,hashves
      data     comb/1,5,1,6,2,3,2,4,3,5,3,6,4,5,4,6/
 
      logical new
c
      do i=1,8
          x(1)=dom(comb(1,i),j)
          x(2)=dom(comb(2,i),j)
          call order(x(1),x(2))
c          print*,i,comb(1,i),comb(2,i),x
          if (x(1)*x(2).ne.0) then
             call loadando(x,dom,8,dommax,ndom,k,new)
             if (new) then
c--------------- don't expand "inbred" records
                if (x(1).eq.x(2)) then
                   dom(7,k)=3
                  else
                   dom(7,k)=1
                endif
             endif
          endif
      enddo
      dom(7,j)=3
      return
c
      entry tag(j,dom,dommax,ndom)
c add 1 to all entries that are referenced by combination j
      do i=1,8
          x(1)=dom(comb(1,i),j)
          x(2)=dom(comb(2,i),j)
          call order(x(1),x(2))
c          print*,i,comb(1,i),comb(2,i),x
          if (x(1)*x(2).ne.0) then
          k=hashves(x,2,dom,dommax,8,0,ndom)
             dom(7,k)=dom(7,k)+1
          endif
      enddo
c
c  tag subclasses that are mandatory to retain positive-definite R
      do i=3,4
         do k=5,6
            x(1)=dom(i,j)
            x(2)=dom(k,j)
            call order(x(1),x(2))
c            print*,i,comb(1,i),comb(2,i),x
            if (x(1)*x(2).ne.0) then
               l=hashves(x,2,dom,dommax,8,0,ndom)
               dom(7,l)=dom(7,l)+1
            endif
         enddo
      enddo
c
      end


      subroutine creat1dom(dom,d,dommax,unit,unit1,id)
c from a hash table dom write the dominance file to unit using
c offset; write ids to unit1.
      integer d,dommax,unit,dom(d,dommax),table(2,8),x(10),y(2),
     +        i,j,k,l,m,n,unit1
      character id(dommax)*(*),a*100
      data table/1,5,1,6,2,3,2,4,3,5,3,6,4,5,4,6/

      do i=1,dommax
         if (dom(7,i).ne.0) then
           write(unit1,'(i8,1x,a,1x,a)')dom(8,i),(id(dom(j,i)),j=1,2)
           if (dom(3,i)+dom(4,i)+dom(5,i)+dom(6,i).ne.0 ) then
              m=0
              x(1)=dom(8,i)
              do j=1,8
                 y(1)=dom(table(1,j),i)
                 y(2)=dom(table(2,j),i)
                 if (y(1)*y(2).ne.0) then
                    call checkando(y,dom,d,dommax,l,k)
                    if (k.ne.0) then
                       x(j+1)=dom(8,k)
                       m=ibset(m,j-1)
                     else
                       x(j+1)=0
                    endif
                  else
                       x(j+1)=0
                   endif
              enddo
              x(10)=m
              call pack(a,n,x,10)
              write(unit,'(a,1x,a,1x,a)')a(1:n)
           endif
         endif
      enddo
      end

      subroutine loadando(x,dom,size,dommax,ndom,k,new)
c loads pair of animals in x into hash table dom
      integer x(2),dommax,size,ndom,k,dom(size,dommax),hashves,ndomold
      logical new
c
      call order(x(1),x(2))
      ndomold=ndom
      k=hashves(x,2,dom,dommax,size,1,ndom)
      new=ndom.ne.ndomold
      return
c
      entry checkando(x,dom,size,dommax,ndom,k)
      call order(x(1),x(2))
      k=hashves(x,2,dom,dommax,size,0,ndom)
      end

      subroutine order(a,b)
c swaps a and b if a<b.
      integer a,b,i
      if (a.gt.b) then
          i=a
          a=b
          b=i
      endif
      end

      subroutine printtable(text,x,m,n)
c prints text and integer table by columns
      character text*(*)
      integer m,n,x(m,n),i,j
      print*,text
      do i=1,n
         print '(13i6)',i,(x(j,i),j=1,m)
      enddo
      end


      subroutine jaadecode
     +    (namepar,namerel,namerec,nrellast,nreclast,nposlast,nanimpos)
c reads parameter file in JAA format and decodes name of pedigre file (namerel),
c records file (namerec), number of pedigree records (nrellast), number
c of animals in records (nreclast),last number to consider in the records
c file (nposlast) and animal position in the records' file.
      integer nrellast,nreclast,nposlast,nanimpos,i,j,
     +        neff,recpos
      character namepar*(*),namerel*(*),namerec*(*)
      real table(3,20)

      open(10,file=namepar)
      read(10,'(a)',end=10)namerec
      read(10,'(a)',end=10)namerel
      read(10,*,end=10)
      read(10,*,end=10)neff,recpos
      do i=1,neff
         read(10,*,end=10) (table(j,i),j=1,3)
      enddo
      if (table(3,neff).ge.0) then
         print*,'last effect in',namepar,' is not animal'
         stop
        else
         nanimpos=table(1,neff)
         nrellast=table(2,neff)
         nposlast=max(recpos,nanimpos)
      endif
      if (neff.ge.2 .and. table(1,neff).eq.table(1,neff-1)) then
           nreclast=table(2,neff-1)
        else
           nreclast=nrellast
      endif
      print*,'files: ',namepar,namerel,namerec
c      print*,nrellast,nreclast,nposlast,nanimpos
      close(10)
      return
c
10    print '('' file '',a,'' incomplete'')',namepar
      stop
      end


      subroutine createparfile(name,unit,nrel,ndom,ndomtot,poslast)
c from the original jaa parameter file name write to unit
c a modified parameter file with dominance information
c
      integer unit,nrel,ndom,ndomtot,x(2),i,j,poslast
      real y(3,10)
      character name*(*),fn(3)*40
c
      open(10,file=name)
      read(10,'(a)')fn
      read(10,*)x
      do i=1,x(1)
         read(10,*)(y(j,i),j=1,3)
      enddo
c
c add dominance effect with 0 variance ratio and number of effects
c equal to all dominance levels;also add inbreeding for regressions
      x(1)=x(1)+1
      y(1,x(1))=poslast+2
      y(2,x(1))=ndomtot
      y(3,x(1))=10
      write(unit,'(a)')'domrec'//fn(1),'d'//fn(2),fn(3)
      write(unit,'(2i3,f4.1,i2)')x(1)+1,x(2),0.85,1
      write(unit,'(3i8)')((int(y(j,i)),j=1,3),i=1,1)
c inbreeding 
      write(unit,'(3i8)')poslast+1,-1,0
      write(unit,'(3i8)')((int(y(j,i)),j=1,3),i=2,x(1))
c add numbers of:
c 1. animals in pedigree file
c 2. records in dominance file
      write(unit,'(5i8)')nrel,ndom
      end


      subroutine inbr(rel,maxanim)
c calculate inbreeding using subroutines from program HAIBB;
c
c round relates to the iterative procedure in Van Raden's algorithm
c in 1992 JDS.

      integer maxanim,rel(4,maxanim),round/1/,i,j,ninb(100),age
      real aveinb(100),sum
c
      print '(/,'' Inbreeding'')'
      do i=1,round
         call inbreed(maxanim,rel,aveinb,i)
         do j=1,100
            aveinb(i)=0
            ninb(i)=0
         enddo
         do j=1,maxanim
            sum=sum+rel(4,j)
            if (rel(1,j).ne.0 .and. rel(2,j).ne.0) then
               age=rel(3,j)
               aveinb(age)=aveinb(age)+rel(4,j)
               ninb(age)=ninb(age)+1
            endif
         enddo
         print*,'average inbreeding=',sum/1000./maxanim
         print '(''  year    #   average inbreeding'')'
         do j=1,100
            if (ninb(j).ne.0) then
               aveinb(j)=aveinb(j)/ninb(j)/1000.
               print '(i4.2,i7,f8.3)',j,ninb(j),aveinb(j)
            endif
         enddo
      enddo
      end


      subroutine  creatrel(nrel,maxanim,rel,id,unin,unout)
c add inbreeding information to pedigree list
      integer nrel,maxanim,rel(4,maxanim),unin,unout,x(4),n,i
      real status
      character a*80,id(maxanim)*(*)
c
      rewind unin
      do i=1,nrel
          read(unin,*)x
          status=4./(x(4)+1)/(1-rel(4,x(1))/1000.)
          x(4)=status*1000
          call pack(a,n,x,4)
          write(unout,'(a,1x,a)')a(1:n),id(x(1))
      enddo
      end
